const { ccclass, property } = cc._decorator;

@ccclass
export default class Helloworld extends cc.Component {
    @property(cc.Node)
    sp: cc.Node = null;

    private animState1: cc.AnimationState;
    private animState2: cc.AnimationState;
    private animation: cc.Animation;

    start() {
        this.animation = this.sp.getComponent(cc.Animation);
        this.animState1 = this.animation.getAnimationState("testAnim");
        this.animState2 = this.animation.getAnimationState("testAnim2");

        this.animation.on('finished', () => {
            cc.log("finished by animation");
        });

        this.animState1.on('finished', () => {
            cc.log("finished by animState1");
        }, this);

        this.animState2.on('finished', () => {
            cc.log("finished by animState2");
        }, this);
    }

    // 调用f1,f2 没有回调
    // 调用f3,f4 有回调
    // 调用f3,f4以后再调用f1,f2有回调

    // animstate一直没回调

    f1() {
        this.animState1.play();
    }

    f2() {
        this.animState2.play();
    }

    f3() {
        this.animation.play("testAnim");
    }

    f4() {
        this.animation.play("testAnim2");
    }
}
